Index: cpp/tests/geometry_goals/f1.goal
===================================================================
--- cpp/tests/geometry_goals/f1.goal	(revision 1263)
+++ cpp/tests/geometry_goals/f1.goal	(revision 1320)
@@ -4,24 +4,24 @@
 p:sh=2, sx=0.05, sy=0.5, sz=0.05, vr=0.0, 1.0, 0.0
 p:sh=2, sx=0.05, sy=0.05, sz=0.5, vr=0.0, 0.0, 1.0
-p:y=-0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:y=-0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:y=0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:y=0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:3.4767959999999998, -0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:3.4767959999999998, -0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:3.4767959999999998, 0.8325007346354043, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:3.4767959999999998, 0.8325007346354043, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
-p:1.7383979999999999, sh=2, sx=3.4997300503918867, sy=0.05, sz=0.05, rx=0.2342831811098684, -0.11454484673768733, -3.443227636570292e-17, vr=1.0, 0.0, 0.0
-p:1.7383979999999999, sh=2, sx=0.05, sy=1.7117636757570973, sz=0.05, rx=0.2342831811098684, -0.11454484673768733, -3.443227636570292e-17, vr=0.0, 1.0, 0.0
-p:1.7383979999999999, sh=2, sx=0.05, sy=0.05, sz=0.8923778124409683, rx=0.2342831811098684, -0.11454484673768733, -3.443227636570292e-17, vr=0.0, 0.0, 1.0
-p:0.3325, sh=3, sx=0.3325, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:0.6649984710283758, -0.41624999999719187, sh=3, sx=0.41624999999999995, sy=0.2, sz=0.2, rz=1.5707926535897934
-p:0.9556250000000001, sh=3, sx=0.290625, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:1.5264060000000002, sh=3, sx=0.28015599999999996, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:1.8065605671634997, -0.3900779999973684, sh=3, sx=0.390078, sy=0.2, sz=0.2, rz=1.5707926535897931
-p:2.19664, sh=3, sx=0.3900779999999999, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:3.031757, sh=3, sx=0.44503899999999996, sy=0.2, sz=0.2, rx=-1.5707963267948966, rz=3.141592653589793
-p:1.8065605671634997, 0.3900779999973684, sh=3, sx=0.390078, sy=0.2, sz=0.2, rz=-1.5707926535897931
-p:0.6649984710283758, 0.41624999999719187, sh=3, sx=0.41624999999999995, sy=0.2, sz=0.2, rz=-1.5707926535897934
+p:y=-0.8325005509751492, -0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:y=-0.8325005509751492, 0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:y=0.8325005509751492, -0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:y=0.8325005509751492, 0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, -0.8325005509751492, -0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, -0.8325005509751492, 0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, 0.8325005509751492, -0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:3.4767959999999998, 0.8325005509751492, 0.15, sh=1, sx=0.05, sy=0.05, sz=0.05, vr=1.0, 1.0, 0.0
+p:1.7383979999999999, sh=2, sx=3.4897149490489903, sy=0.05, sz=0.05, rx=0.1776213289780406, -0.08607314756290158, -3.2671104874555106e-17, vr=1.0, 0.0, 0.0
+p:1.7383979999999999, sh=2, sx=0.05, sy=1.6916145755300782, sz=0.05, rx=0.1776213289780406, -0.08607314756290158, -3.2671104874555106e-17, vr=0.0, 1.0, 0.0
+p:1.7383979999999999, sh=2, sx=0.05, sy=0.05, sz=0.6791989526823026, rx=0.1776213289780406, -0.08607314756290158, -3.2671104874555106e-17, vr=0.0, 0.0, 1.0
+p:0.3325, sh=3, sx=0.3325, sy=0.15, sz=0.15, rx=-1.5707963267948966, rz=3.141592653589793
+p:0.6649984710283758, -0.41624999999719187, sh=3, sx=0.41624999999999995, sy=0.15, sz=0.15, rz=1.5707926535897934
+p:0.9556250000000001, sh=3, sx=0.290625, sy=0.15, sz=0.15, rx=-1.5707963267948966, rz=3.141592653589793
+p:1.5264060000000002, sh=3, sx=0.28015599999999996, sy=0.15, sz=0.15, rx=-1.5707963267948966, rz=3.141592653589793
+p:1.8065605671634997, -0.3900779999973684, sh=3, sx=0.390078, sy=0.15, sz=0.15, rz=1.5707926535897931
+p:2.19664, sh=3, sx=0.3900779999999999, sy=0.15, sz=0.15, rx=-1.5707963267948966, rz=3.141592653589793
+p:3.031757, sh=3, sx=0.44503899999999996, sy=0.15, sz=0.15, rx=-1.5707963267948966, rz=3.141592653589793
+p:1.8065605671634997, 0.3900779999973684, sh=3, sx=0.390078, sy=0.15, sz=0.15, rz=-1.5707926535897931
+p:0.6649984710283758, 0.41624999999719187, sh=3, sx=0.41624999999999995, sy=0.15, sz=0.15, rz=-1.5707926535897934
 j:0, 1, sh=1
 j:0, 2, sh=1
@@ -48,12 +48,12 @@
 j:0, 15, sh=1
 
-# volume=0.463110
-# area=7.221219
-# sizes.x=3.499730 sizes.y=1.711764 sizes.z=0.892378
-# axes.x=(0.993447, -0.000000, -0.114295)
-# axes.y=(0.026533, 0.972681, 0.230625)
-# axes.z=(0.111172, -0.232146, 0.966307)
+# volume=0.347332
+# area=5.180295
+# sizes.x=3.489715 sizes.y=1.691615 sizes.z=0.679199
+# axes.x=(0.996298, -0.000000, -0.085967)
+# axes.y=(0.015189, 0.984267, 0.176035)
+# axes.z=(0.084614, -0.176689, 0.980623)
 # box.x=[0.000000, 3.476796]
 # box.y=[-0.832501, 0.832501]
-# box.z=[-0.200000, 0.200000]
+# box.z=[-0.150000, 0.150000]
 