Index: cpp/frams/model/model.cpp
===================================================================
--- cpp/frams/model/model.cpp	(revision 1318)
+++ cpp/frams/model/model.cpp	(revision 1323)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2023  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2024  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -1289,5 +1289,5 @@
 }
 
-void Model::buildUsingSolidShapeTypes(const Model &src_ballandstick_shapes, Part::Shape use_shape, double thickness)
+void Model::buildUsingSolidShapeTypes(const Model &src_ballandstick_shapes, Part::Shape use_shape, double radius)
 {
 	for (int i = 0; i < src_ballandstick_shapes.getJointCount(); i++)
@@ -1300,6 +1300,6 @@
 		p->setRot(o.getAngles());
 		p->scale.x = oj->part1->p.distanceTo(oj->part2->p) / 2;
-		p->scale.y = thickness;
-		p->scale.z = thickness;
+		p->scale.y = radius;
+		p->scale.z = radius;
 	}
 	if (src_ballandstick_shapes.getJointCount() == 0) //single part "ball-and-stick" models are valid so let's make a valid solid shape model
@@ -1310,5 +1310,5 @@
 			p->p = op->p;
 			p->rot = op->rot;
-			p->scale.x = p->scale.y = p->scale.z = thickness;
+			p->scale.x = p->scale.y = p->scale.z = radius;
 		}
 	for (int i = 0; i < src_ballandstick_shapes.getPartCount(); i++)
@@ -1334,5 +1334,5 @@
 }
 
-SolidsShapeTypeModel::SolidsShapeTypeModel(Model &m, Part::Shape use_shape, double thickness)
+SolidsShapeTypeModel::SolidsShapeTypeModel(Model &m, Part::Shape use_shape, double radius)
 {
 	using_model = converted_model = NULL;
@@ -1341,5 +1341,5 @@
 		converted_model = new Model;
 		converted_model->open();
-		converted_model->buildUsingSolidShapeTypes(m, use_shape, thickness);
+		converted_model->buildUsingSolidShapeTypes(m, use_shape, radius);
 		converted_model->close();
 		using_model = converted_model;
Index: cpp/frams/model/model.h
===================================================================
--- cpp/frams/model/model.h	(revision 1318)
+++ cpp/frams/model/model.h	(revision 1323)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2021  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2024  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -390,5 +390,5 @@
 
 	/// build this model using solid shape types, based on the provided ball-and-stick model. See also shapeconvert.cpp.
-	void buildUsingSolidShapeTypes(const Model &src_ballandstick_shapes, Part::Shape use_shape = Part::SHAPE_CYLINDER, double thickness = Part::DEFAULT_STICK_RADIUS);
+	void buildUsingSolidShapeTypes(const Model &src_ballandstick_shapes, Part::Shape use_shape = Part::SHAPE_CYLINDER, double radius = Part::BALL_AND_STICK_RADIUS);
 
 protected:
@@ -443,5 +443,5 @@
 	Model *converted_model;
 	Model *using_model;
-	SolidsShapeTypeModel(Model &m, Part::Shape use_shape = Part::SHAPE_CYLINDER, double thickness = Part::DEFAULT_STICK_RADIUS);
+	SolidsShapeTypeModel(Model &m, Part::Shape use_shape = Part::SHAPE_CYLINDER, double radius = Part::BALL_AND_STICK_RADIUS);
 	operator Model &() { return *using_model; }
 	Model &getModel() { return *using_model; }
Index: cpp/frams/model/modelparts.h
===================================================================
--- cpp/frams/model/modelparts.h	(revision 1318)
+++ cpp/frams/model/modelparts.h	(revision 1323)
@@ -1,4 +1,4 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2021  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2024  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
@@ -103,5 +103,5 @@
 	};
 	static const char* getShapeName(Shape sh);
-	static constexpr double DEFAULT_STICK_RADIUS = 0.15; //used in odesim, VisualModel, CreatureObj3D, and SHAPETYPE_BALL_AND_STICK to SHAPETYPE_SOLIDS Model conversion
+	static constexpr double BALL_AND_STICK_RADIUS = 0.15; //used in odesim, VisualModel, CreatureObj3D, and SHAPETYPE_BALL_AND_STICK to SHAPETYPE_SOLIDS Model conversion
 
 	double mass, size, density, friction, ingest, assim, hollow;