Index: js/standard_expdef_demo/index.html
===================================================================
--- js/standard_expdef_demo/index.html	(revision 880)
+++ js/standard_expdef_demo/index.html	(revision 1326)
@@ -5,26 +5,78 @@
     <meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
     <link rel="stylesheet" type="text/css" href="static/styles.css">
-		<title>Standard.expdef Animation</title>
+		<title>Standard.expdef demo animation</title>
+	<script type="importmap">
+		{
+			"imports": {
+				"three": "./node_modules/three/build/three.module.js",
+				"three/addons/OrbitControls.js": "./node_modules/three/examples/jsm/controls/OrbitControls.js",
+				"three/addons/CSS3DRenderer.js": "./node_modules/three/examples/jsm/renderers/CSS3DRenderer.js",
+				"three/addons/Sky.js": "./node_modules/three/examples/jsm/objects/Sky.js",
+				"tween": "./node_modules/three/examples/jsm/libs/tween.module.js"
+			}
+		}
+	</script>
+	<script type="module">
+		import * as TWEEN from 'tween';
+		import * as THREE from 'three';
+		import {OrbitControls} from "three/addons/OrbitControls.js";
+		import {CSS3DObject, CSS3DSprite, CSS3DRenderer} from "three/addons/CSS3DRenderer.js";
+		import {Sky} from "three/addons/Sky.js";
+
+		// this trick is done to avoid refactoring the entire app
+		window.THREE = THREE;
+		window.Sky = Sky;
+		window.OrbitControls = OrbitControls;
+		window.CSS3DRenderer = CSS3DRenderer;
+		window.CSS3DObject = CSS3DObject;
+		window.CSS3DSprite = CSS3DSprite;
+		window.TWEEN = TWEEN;
+	</script>
+
+
+    
+		
 	</head>
 	<body style="margin: 0; overflow: hidden;">
-    <!--External dependencies-->
-		<script src="js/external/threejs/three.min.js"></script>
-    <script src="js/external/threejs/CSS3DRenderer.js"></script>
-    <script src="js/external/threejs/OrbitControls.js"></script>
-    <script src="js/external/threejs/Sky.js"></script>
-    <script src="js/external/tweenjs/tween.min.js"></script>
-    <script src="../sdk/frams-sdk.js"></script>
-    <script src="js/external/framsjs/visualization/jointmeshfactory.js"></script>
-    <script src="js/external/framsjs/visualization/partmeshfactory.js"></script>
-    <script src="js/external/framsjs/visualization/transformations.js"></script>
-    <!--Project sources-->
-    <script src="js/config.js"></script>
-    <script src="js/world/core.js"></script>
-    <script src="js/world/object/framstick.js"></script>
-    <script src="js/world/object/table.js"></script>
-    <script src="js/world/object/text.js"></script>
-    <script src="js/world/object/arrow.js"></script>
-    <script src="js/simulation/core.js"></script>
-		<script src="js/app.js"></script>
+		<div class="column controls">
+			<div class="row control-container" id="fitness-rater">
+				<span>Rate creature:</span>
+			</div>
+			<div class="row control-container">
+				<span>Genotype: </span>
+				<select id="genotype-selector">
+				</select>
+			</div>
+			
+		</div>
+		<!--External dependencies-->
+		
+		<!-- <script src="js/external/threejs/three.min.js"></script>
+		<script src="js/external/threejs/CSS3DRenderer.js"></script>
+		<script src="js/external/threejs/OrbitControls.js"></script>
+		<script src="js/external/threejs/Sky.js"></script> -->
+		<!-- <script src="js/external/tweenjs/tween.min.js"></script> -->
+		<script src="sdk/frams-sdk.js"></script>
+		<script src="js/external/framsjs/visualization/jointmeshfactory.js" defer></script>
+		<script src="js/external/framsjs/visualization/partmeshfactory.js" defer></script>
+		<script src="js/external/framsjs/visualization/transformations.js" defer></script>
+		<!--Project sources-->
+		<script src="js/config.js" defer></script>
+		<script src="js/utils.js" defer></script>
+		<script src="js/world/core.js" defer></script>
+		<script src="js/world/object/framstick.js" defer></script>
+		<script src="js/world/object/table.js"></script>
+		<script src="js/world/object/text.js" defer></script>
+		<script src="js/world/object/arrow.js" defer></script>
+		<script src="js/neuroviewer/view.js" defer></script>
+		<script src="js/neuroviewer/neurofactory.js" defer></script>
+		<script src="js/neuroviewer/neurons/basedrawableneuron.js" defer></script>
+		<script src="js/neuroviewer/neurons/genericdrawableneuron.js" defer></script>
+		<script src="js/neuroviewer/neurons/receptordrawableneuron.js" defer></script>
+		<script src="js/components/slider.js" defer></script>
+		<script src="js/components/option.js" defer></script>
+		<script src="js/components/button.js" defer></script>
+		<script src="js/simulation/core.js" defer></script>
+		<script src="js/app.js" defer></script>
 	</body>
 </html>